'use strict';
const fs = require('fs')
const express = require('express')
const bodyParser = require('body-parser')
const low = require('lowdb')
const exec = require('child_process').exec
const usageFilePath = './usage.json'
try {
	fs.statSync(usageFilePath).isFile()
} catch (e) {
	fs.writeFileSync(usageFilePath, fs.readFileSync(usageFilePath.replace('.json', '_default.json')))
}

const db = low(usageFilePath)
const app = express()
app.use(bodyParser.json())
app.use(bodyParser.urlencoded({ extended: true }))

app.get('/usepage', function (req, res) {
  res.sendFile('./usepage.html', {root: __dirname})
})

app.get('/', function (req, res) {
  res.sendFile('./index.html', {root: __dirname})
})

app.get('/usage', function (req, res) {
  res.json({
  	machine : db.get('machine')
  })
})

app.all('/wiki/update', function(req, res){
	const WIKI_PATH = '/home/wiki'
	const commands = [
		'cd ' + WIKI_PATH,
		'git pull'
	].join('&&')

	exec(commands, function(err,out){
		if(err instanceof Error){
			res.writeHead(500)
			res.end('Hook error')
			throw err
		}
    res.status(200).end()
	})
})

app.all('/bjgee/update', function(req, res){
	const BJGEE_PATH = '/home/bjgee'
	// const BJGEE_PATH = '/Users/shangbj/Documents/个人项目/bjgee'
	const commands = [
		'cd ' + BJGEE_PATH,
		'git pull origin master',
		'npm run generate'
	].join('&&')

	exec(commands, function(err,out){
		if(err instanceof Error){
			res.writeHead(500)
			res.end('Hook error')
			throw err
		}
    	res.status(200).end()
	})
})

app.post('/register', function(req, res){
	const site = req.body.site
	const machine = req.body.machine
	const branch = req.body.branch
	const project = req.body.project
	if(machine && machine.length){
		machine.forEach(machine => {
			const source = db.get('machine').get(site).find({name: machine}).get('inUse')
			const item = source.find({branch})

			if(item.value()){
				item.assign({project}).write()
			}else{
				source.push({project, branch}).write()
			}
		})
	}

	res.json({ret: true})
})

app.post('/unregister', function(req, res){
	const site = req.body.site
	const branch = req.body.branch
	const machines = db.get('machine').get(site)
	if(branch){
		machines.value().forEach(machine => {
			const source = machines.find({name: machine.name}).get('inUse')
			source.remove({branch}).write()
		})
	}

	res.json({ret: true})
})

app.listen(3001, function () {
  console.log('app listening on port 3001!')
})